/**
 * PQ.java
 *
 * File generated from the datatypes::PQ uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.ips.datatypes;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class PQ.
 *
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "PQ", propOrder = {
	"translation",
	"unit",
	"value"
})
@XmlRootElement(name = "PQ")
public class PQ extends net.ihe.gazelle.ips.datatypes.QTY implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	/**
	 *  An alternative representation of the same physical quantity expressed in a different unit, of a different unit code system and possibly with a different value. .
	 */
	@XmlElement(name = "translation", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.ips.datatypes.PQR> translation;
	/**
	 *  The unit of measure specified in the Unified Code for Units of Measure (UCUM) [http://aurora.rg.iupui.edu/UCUM]. .
	 */
	@XmlAttribute(name = "unit")
	public String unit;
	/**
	 *  The magnitude of the quantity measured in terms of the unit. .
	 */
	@XmlAttribute(name = "value")
	@javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter(net.ihe.gazelle.adapters.DoubleAdapter.class)
	public Double value;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private Node _xmlNodePresentation;
	
	
	/**
	 * Return translation.
	 * @return translation :  An alternative representation of the same physical quantity expressed in a different unit, of a different unit code system and possibly with a different value. 
	 */
	public List<net.ihe.gazelle.ips.datatypes.PQR> getTranslation() {
		if (translation == null) {
	        translation = new ArrayList<net.ihe.gazelle.ips.datatypes.PQR>();
	    }
	    return translation;
	}
	
	/**
	 * Set a value to attribute translation.
	 * @param translation :  An alternative representation of the same physical quantity expressed in a different unit, of a different unit code system and possibly with a different value. .
	 */
	public void setTranslation(List<net.ihe.gazelle.ips.datatypes.PQR> translation) {
	    this.translation = translation;
	}
	
	
	
	/**
	 * Add a translation to the translation collection.
	 * @param translation_elt Element to add.
	 */
	public void addTranslation(net.ihe.gazelle.ips.datatypes.PQR translation_elt) {
	    this.getTranslation().add(translation_elt);
	}
	
	/**
	 * Remove a translation to the translation collection.
	 * @param translation_elt Element to remove
	 */
	public void removeTranslation(net.ihe.gazelle.ips.datatypes.PQR translation_elt) {
	    this.getTranslation().remove(translation_elt);
	}
	
	/**
	 * Return unit.
	 * @return unit :  The unit of measure specified in the Unified Code for Units of Measure (UCUM) [http://aurora.rg.iupui.edu/UCUM]. 
	 */
	public String getUnit() {
	    return unit;
	}
	
	/**
	 * Set a value to attribute unit.
	 * @param unit :  The unit of measure specified in the Unified Code for Units of Measure (UCUM) [http://aurora.rg.iupui.edu/UCUM]. .
	 */
	public void setUnit(String unit) {
	    this.unit = unit;
	}
	
	
	
	
	/**
	 * Return value.
	 * @return value :  The magnitude of the quantity measured in terms of the unit. 
	 */
	public Double getValue() {
	    return value;
	}
	
	/**
	 * Set a value to attribute value.
	 * @param value :  The magnitude of the quantity measured in terms of the unit. .
	 */
	public void setValue(Double value) {
	    this.value = value;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.ips.datatypes");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "PQ").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	
	/**
	 * Description of the method cdaEquals.
	 *
	 * @param pq1
	 * @return ret
	 */
	public Boolean cdaEquals(net.ihe.gazelle.ips.datatypes.PQ pq1) {
		if (unit == null) {
			if (pq1.unit != null)
				return false;
		}
		if (unit == null || unit.equals(pq1.unit)){
			if (value == null) {
				if (pq1.value != null)
					return false;
			} else if (!value.equals(pq1.value))
				return false;
		}
		return true;
	}
		

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(PQ pQ, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (pQ != null){
   			net.ihe.gazelle.ips.datatypes.QTY.validateByModule(pQ, _location, cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.PQR translation: pQ.getTranslation()){
					net.ihe.gazelle.ips.datatypes.PQR.validateByModule(translation, _location + "/translation[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
    	}
    }

}